<template>
  <b-container class="large-container">
    <div class="d-flex justify-content-around">
      <div class="text-box">
        <h1>Sample Catalog Data</h1>
        <p>
          This page displays sample data from ANTARES' static object catalogs. The purpose of this
          page is to document catalog schema and enable Filter development. You can also access
          sample catalog data in the DevKit like this:
        </p>
        <pre>
          <code>
            import antares.devkit as dk
            dk.init()
            data = dk.get_sample_catalog_data()
          </code>
        </pre>
        <hr>
      </div>
    </div>
    <div v-if="status === Status.LOADING">
      <content-loader-table />
    </div>
    <div v-else-if="status === Status.SUCCESS">
      <div
        v-for="name of names"
        :key="name"
        class="mb-4"
      >
        <h2>{{ name }}</h2>
        <b-table
          :items="tables[name]"
          responsive
          small
          style="white-space: nowrap;"
        />
      </div>
    </div>
    <div v-else-if="status === Status.ERROR">
      <b-list-group>
        <b-list-group-item variant="danger">
          <h5>Error Loading Catalogs</h5>
          <p>There was an error loading catalog data.</p>
          <pre>{{ JSON.stringify(errorMessage, null, 2) }}</pre>
        </b-list-group-item>
      </b-list-group>
    </div>
  </b-container>
</template>

<script lang="ts">
import Vue from 'vue';
import * as _ from 'lodash';

import { CatalogSampleService } from '@/api';
import ContentLoaderTable from '@/components/ContentLoaderTable.vue';

/* eslint-disable-next-line no-shadow */
enum Status {
  ERROR = 'ERROR',
  LOADING = 'LOADING',
  SUCCESS = 'SUCCESS',
}

export default Vue.extend({
  components: {
    ContentLoaderTable,
  },

  data() {
    return {
      Status,
      errorMessage: '',
      names: [] as string[], // list of catalog names
      status: Status.LOADING,
      tables: Object(), // map: catalog_name --> table rows
    };
  },

  mounted() {
    this.fetchCatalogSamples();
  },

  methods: {
    async fetchCatalogSamples() {
      this.status = Status.LOADING;
      try {
        const response = await CatalogSampleService.list({});
        const tables = _.groupBy(response.data, 'catalog_name');
        this.names = _.keys(tables);
        this.tables = _.mapValues(tables, (rows) => rows.map((cs) => cs.data));
        this.status = Status.SUCCESS;
      } catch (error) {
        this.status = Status.ERROR;
        /* eslint-disable-next-line prefer-destructuring */
        this.errorMessage = error[0];
      }
    },
  },
});
</script>

<style scoped>
.b-table {
  background-color: white;
}
</style>
